    async def translate_with_free_google(self, text: str, source_lang: str, target_lang: str) -> Optional[str]:
        """Translate using free Google Translate (no API key required)"""
        try:
            if not self.free_google_translator:
                return None
            
            # Use the free Google Translate service
            result = self.free_google_translator.translate(text, dest=target_lang, src=source_lang)
            
            if result and result.text and result.text != text:
                return result.text.strip()
            
            return None
            
        except Exception as e:
            logger.error("Error in free Google translation", 
                        error=str(e), source=source_lang, target=target_lang)
            return None
    
    async def translate_with_argos(self, text: str, source_lang: str, target_lang: str) -> Optional[str]: